Create a Fireworks AI inference endpoint Generally available

PUT /_inference/{task_type}/{fireworksai_inference_id}

Create an inference endpoint to perform an inference task with the fireworksai service.

Required authorization

  • Cluster privileges: manage_inference

Path parameters

  • task_type string

    The type of the inference task that the model will perform.

    Values are chat_completion, completion, or text_embedding.

  • fireworksai_inference_id string Required

    The unique identifier of the inference endpoint.

Query parameters

application/json

Body Required

  • chunking_settings object

    The chunking configuration object. Applies only to the text_embedding task type. Not applicable to the completion or chat_completion task types.

    External documentation
    Hide chunking_settings attributes Show chunking_settings attributes object
    • max_chunk_size number

      The maximum size of a chunk in words. This value cannot be lower than 20 (for sentence strategy) or 10 (for word strategy). This value should not exceed the window size for the associated model.

      Default value is 250.

    • overlap number

      The number of overlapping words for chunks. It is applicable only to a word chunking strategy. This value cannot be higher than half the max_chunk_size value.

      Default value is 100.

    • sentence_overlap number

      The number of overlapping sentences for chunks. It is applicable only for a sentence chunking strategy. It can be either 1 or 0.

      Default value is 1.

    • separator_group string

      Only applicable to the recursive strategy and required when using it.

      Sets a predefined list of separators in the saved chunking settings based on the selected text type. Values can be markdown or plaintext.

      Using this parameter is an alternative to manually specifying a custom separators list.

    • separators array[string]

      Only applicable to the recursive strategy and required when using it.

      A list of strings used as possible split points when chunking text.

      Each string can be a plain string or a regular expression (regex) pattern. The system tries each separator in order to split the text, starting from the first item in the list.

      After splitting, it attempts to recombine smaller pieces into larger chunks that stay within the max_chunk_size limit, to reduce the total number of chunks generated.

    • strategy string

      The chunking strategy: sentence, word, none or recursive.

      • If strategy is set to recursive, you must also specify:

        • max_chunk_size
        • either separators orseparator_group

      Learn more about different chunking strategies in the linked documentation.

      Default value is sentence.

      External documentation
  • service string Required

    The type of service supported for the specified task type. In this case, fireworksai.

    Value is fireworksai.

  • service_settings object Required

    Settings used to install the inference model. These settings are specific to the fireworksai service.

    Hide service_settings attributes Show service_settings attributes object
    • api_key string Required

      A valid API key for your Fireworks AI account. You can find or create your API keys in the Fireworks AI dashboard.

      IMPORTANT: You need to provide the API key only once, during the inference model creation. The get inference endpoint API does not retrieve your API key.

      External documentation
    • model_id string Required

      The name of the model to use for the inference task. Refer to the Fireworks AI documentation for the list of available models for chat completion, completion, and text embedding. For text embedding, supported models include the Qwen3 embedding family (e.g. fireworks/qwen3-embedding-8b) and other models in the Fireworks model library.

      External documentation
    • url string

      The URL endpoint to use for the requests. If not provided, the default Fireworks AI API endpoint is used.

    • dimensions number

      For a text_embedding task, the number of dimensions the resulting output embeddings should have. Variable-length embeddings are supported via this parameter.

    • similarity string

      For a text_embedding task, the similarity measure. One of cosine, dot_product, l2_norm.

      Values are cosine, dot_product, or l2_norm.

    • rate_limit object

      This setting helps to minimize the number of rate limit errors returned from the Fireworks AI API. Rate limit grouping is per API key only. By default, the fireworksai service sets the number of requests allowed per minute to 6000.

      External documentation
      Hide rate_limit attribute Show rate_limit attribute object
      • requests_per_minute number

        The number of requests allowed per minute. By default, the number of requests allowed per minute is set by each service as follows:

        • alibabacloud-ai-search service: 1000
        • amazonbedrock service: 240
        • anthropic service: 50
        • azureaistudio service: 240
        • azureopenai service and task type text_embedding: 1440
        • azureopenai service and task types completion or chat_completion: 120
        • cohere service: 10000
        • contextualai service: 1000
        • elastic service and task type chat_completion: 240
        • fireworksai service: 6000
        • googleaistudio service: 360
        • googlevertexai service: 30000
        • hugging_face service: 3000
        • jinaai service: 2000
        • llama service: 3000
        • mistral service: 240
        • openai service and task type text_embedding: 3000
        • openai service and task type completion: 500
        • openshift_ai service: 3000
        • voyageai service: 2000
        • watsonxai service: 120
  • task_settings object

    Settings to configure the inference task. Applies only to the completion or chat_completion task types. Not applicable to the text_embedding task type. These settings are specific to the task type you specified.

    Hide task_settings attributes Show task_settings attributes object
    • user string

      For a completion orchat_completion task, specify the user issuing the request. This information can be used for abuse detection.

    • headers object

      For a completion orchat_completion task. Specifies custom HTTP header parameters. For example:

      "headers":{
        "Custom-Header": "Some-Value",
        "Another-Custom-Header": "Another-Value"
      }
      

Responses

  • 200 application/json
    Hide response attributes Show response attributes object
    • chunking_settings object

      The chunking configuration object. Applies only to the embedding, sparse_embedding and text_embedding task types. Not applicable to the rerank, completion, or chat_completion task types.

      Hide chunking_settings attributes Show chunking_settings attributes object
      • max_chunk_size number

        The maximum size of a chunk in words. This value cannot be lower than 20 (for sentence strategy) or 10 (for word strategy). This value should not exceed the window size for the associated model.

        Default value is 250.

      • overlap number

        The number of overlapping words for chunks. It is applicable only to a word chunking strategy. This value cannot be higher than half the max_chunk_size value.

        Default value is 100.

      • sentence_overlap number

        The number of overlapping sentences for chunks. It is applicable only for a sentence chunking strategy. It can be either 1 or 0.

        Default value is 1.

      • separator_group string

        Only applicable to the recursive strategy and required when using it.

        Sets a predefined list of separators in the saved chunking settings based on the selected text type. Values can be markdown or plaintext.

        Using this parameter is an alternative to manually specifying a custom separators list.

      • separators array[string]

        Only applicable to the recursive strategy and required when using it.

        A list of strings used as possible split points when chunking text.

        Each string can be a plain string or a regular expression (regex) pattern. The system tries each separator in order to split the text, starting from the first item in the list.

        After splitting, it attempts to recombine smaller pieces into larger chunks that stay within the max_chunk_size limit, to reduce the total number of chunks generated.

      • strategy string

        The chunking strategy: sentence, word, none or recursive.

        • If strategy is set to recursive, you must also specify:

          • max_chunk_size
          • either separators orseparator_group

        Learn more about different chunking strategies in the linked documentation.

        Default value is sentence.

        External documentation
    • service string Required

      The service type

    • service_settings object Required

      Settings specific to the service

    • task_settings object

      Task settings specific to the service and task type

    • inference_id string Required

      The inference Id

    • task_type string Required

      The task type

      Values are chat_completion, completion, or text_embedding.

PUT /_inference/{task_type}/{fireworksai_inference_id}
PUT _inference/text_embedding/my-fireworks-embeddings
{
    "service": "fireworksai",
    "service_settings": {
        "api_key": "your-api-key",
        "model_id": "fireworks/qwen3-embedding-8b"
    }
}
resp = client.inference.put(
    task_type="text_embedding",
    inference_id="my-fireworks-embeddings",
    inference_config={
        "service": "fireworksai",
        "service_settings": {
            "api_key": "your-api-key",
            "model_id": "fireworks/qwen3-embedding-8b"
        }
    },
)
const response = await client.inference.put({
  task_type: "text_embedding",
  inference_id: "my-fireworks-embeddings",
  inference_config: {
    service: "fireworksai",
    service_settings: {
      api_key: "your-api-key",
      model_id: "fireworks/qwen3-embedding-8b",
    },
  },
});
response = client.inference.put(
  task_type: "text_embedding",
  inference_id: "my-fireworks-embeddings",
  body: {
    "service": "fireworksai",
    "service_settings": {
      "api_key": "your-api-key",
      "model_id": "fireworks/qwen3-embedding-8b"
    }
  }
)
$resp = $client->inference()->put([
    "task_type" => "text_embedding",
    "inference_id" => "my-fireworks-embeddings",
    "body" => [
        "service" => "fireworksai",
        "service_settings" => [
            "api_key" => "your-api-key",
            "model_id" => "fireworks/qwen3-embedding-8b",
        ],
    ],
]);
curl -X PUT -H "Authorization: ApiKey $ELASTIC_API_KEY" -H "Content-Type: application/json" -d '{"service":"fireworksai","service_settings":{"api_key":"your-api-key","model_id":"fireworks/qwen3-embedding-8b"}}' "$ELASTICSEARCH_URL/_inference/text_embedding/my-fireworks-embeddings"
Request examples
Run `PUT _inference/text_embedding/my-fireworks-embeddings` to create an inference endpoint that performs a `text_embedding` task.
{
    "service": "fireworksai",
    "service_settings": {
        "api_key": "your-api-key",
        "model_id": "fireworks/qwen3-embedding-8b"
    }
}
Create a Fireworks AI text embedding endpoint with custom dimensions, similarity, and rate limit.
{
    "service": "fireworksai",
    "service_settings": {
        "api_key": "your-api-key",
        "model_id": "fireworks/qwen3-embedding-8b",
        "dimensions": 1024,
        "similarity": "cosine",
        "rate_limit": {
            "requests_per_minute": 6000
        }
    }
}
Run `PUT _inference/chat_completion/my-fireworks-chat` to create an inference endpoint that performs a `chat_completion` task.
{
    "service": "fireworksai",
    "service_settings": {
        "api_key": "your-api-key",
        "model_id": "accounts/fireworks/models/deepseek-v3p1"
    }
}
Run `PUT _inference/completion/my-fireworks-completion` to create an inference endpoint that performs a `completion` task.
{
    "service": "fireworksai",
    "service_settings": {
        "api_key": "your-api-key",
        "model_id": "accounts/fireworks/models/deepseek-v3p1"
    }
}
Response examples (200)
A successful response when creating a Fireworks AI `text_embedding` inference endpoint.
{
    "inference_id": "my-fireworks-embeddings",
    "task_type": "text_embedding",
    "service": "fireworksai",
    "service_settings": {
        "model_id": "fireworks/qwen3-embedding-8b",
        "url": "https://api.fireworks.ai/inference/v1/embeddings",
        "similarity": "cosine",
        "dimensions": 4096,
        "rate_limit": {
            "requests_per_minute": 6000
        }
    },
    "chunking_settings": {
        "strategy": "sentence",
        "max_chunk_size": 250,
        "sentence_overlap": 1
    }
}
A successful response when creating a Fireworks AI `chat_completion` inference endpoint.
{
  "inference_id": "my-fireworks-chat",
  "task_type": "chat_completion",
  "service": "fireworksai",
  "service_settings": {
    "model_id": "accounts/fireworks/models/deepseek-v3p1",
    "rate_limit": {
      "requests_per_minute": 6000
    }
  }
}